<?php
// +-------------------------------------------------------------------+
// | $Id: my_tasks_prioritask.php 37 2007-04-03 12:57:30Z haristv $
// +-------------------------------------------------------------------+
// | This is a modified version of the original aciveCollan 0.71
// | file my_tasks.php that adds the Prioritask feature.
// | For more info visit the link below.
// +-------------------------------------------------------------------+
// | http://haris.tv/2007/03/31/prioritask-for-activecollab-071/
// +-------------------------------------------------------------------+
?>
<?php
function htv_shorten($text, $maxsize) {
	$isThisFunctionRequired = true; // temporary switch to turn the function on or off
	if (strlen($text) > $maxsize && $isThisFunctionRequired) {
		$text = substr($text, 0, $maxsize-3) . 
				'<abbr title="...' . substr($text, $maxsize-3 ) . '">...</abbr>';
	}
	return $text;
}

require('SLLists.class.php');
$sortableLists = new SLLists('application/views/dashboard/scriptaculous');	// points to path of scriptaculous JS files

// formatting for the list
$sortableTag = 'li';
$listFormat = '<ul id="sortableList">%s</ul>';
$listItemFormat = '<li id="item_%s" tasklist="%s"%s>%s</li>';

$sortableLists->addList('sortableList','sortableListOrder',$sortableTag);
$sortableLists->debug = false;

if (isset($_POST['sortableListsSubmitted'])) {
	$orderArray = SLLists::getOrderArray($_POST['sortableListOrder'],'sortableList');
	
	$conn = mysql_connect(DB_HOST, DB_USER, DB_PASS);
	mysql_select_db(DB_NAME);
	
	// write the task order
	foreach($orderArray as $item) {
		$sql = "UPDATE " . TABLE_PREFIX . "project_tasks set `order`=".$item['order']." WHERE id=".$item['element'];
		mysql_query($sql);
	}
	
	// write the tasklist order
	if (isset($_POST['taskListOrder'])) {
		$TLPostArr = explode(',',$_POST['taskListOrder']);
		$orderCounter = 1;
		foreach($TLPostArr as $item) {
			$sql = "UPDATE " . TABLE_PREFIX . "project_task_lists set `order`=".$orderCounter." WHERE id=".$item;
			mysql_query($sql);
			$orderCounter += 1;
		}
	}
	
	// redirect to prevent refresh button re-submitting
	header('Location: ' . ROOT_URL . '/index.php?c=dashboard&a=my_tasks#prioritask');
}
?>

<?php 

  // Set page title and set crumbs to index
  set_page_title(lang('my tasks') . ' and Prioritask');
  dashboard_tabbed_navigation(DASHBOARD_TAB_MY_TASKS);
  dashboard_crumbs(lang('my tasks'));
  add_stylesheet_to_page('dashboard/my_tasks.css');

?>
            <div id="page_actions">
              <ul>
                <li><a href="#prioritask">Prioritask</a></li>

              </ul>
            </div>
<?php 
  // If user have any assigned task or milestone this variable will be changed to TRUE
  // else it will remain false
  $has_assigned_tasks = false; 
?>

<?php if(isset($active_projects) && is_array($active_projects) && count($active_projects)) { ?>
<div id="myTasks">
<?php foreach($active_projects as $active_project) { ?>
<?php $htv_project_arr[$active_project->getId()]['name'] = clean($active_project->getName()) ?>
<?php $htv_project_arr[$active_project->getId()]['url'] = $active_project->getOverviewUrl() ?>
<?php
  $assigned_milestones = $active_project->getUsersMilestones(logged_user());
  $assigned_tasks = $active_project->getUsersTasks(logged_user());
?>
<?php if((is_array($assigned_milestones) && count($assigned_milestones)) || (is_array($assigned_tasks) && count($assigned_tasks))) { ?>
<?php $has_assigned_tasks = true ?>
  <div class="block">
    <div class="header"><h2><a href="<?php echo $active_project->getOverviewUrl() ?>"><?php echo clean($active_project->getName()) ?></a></h2></div>
    <div class="content">
<?php if(is_array($assigned_milestones) && count($assigned_milestones)) { ?>
      <p><a href="<?php echo $active_project->getMilestonesUrl() ?>"><?php echo lang('milestones') ?></a>:</p>
      <table class="blank">
<?php foreach($assigned_milestones as $assigned_milestone) { ?>
<?php $htv_milestone_arr[$assigned_milestone->getId()]['name'] = $assigned_milestone->getName() ?>
        <tr>
          <td class="milestoneCheckbox"><?php echo checkbox_link($assigned_milestone->getCompleteUrl(), false) ?></td>
          <td class="milestoneText">
<?php $assigned_to = $assigned_milestone->getAssignedTo() ?>
<?php if($assigned_to instanceof Company) { ?>
            <span class="assignedTo"><?php echo clean($assigned_to->getName()) ?>:</span> 
<?php } elseif($assigned_to instanceof User) { ?>
            <span class="assignedTo"><?php echo clean($assigned_to->getDisplayName()) ?>:</span> 
<?php } else { ?>
            <span class="assignedTo"><?php echo lang('anyone') ?>:</span>
<?php } // if ?>
            <a href="<?php echo $assigned_milestone->getViewUrl() ?>"><?php echo clean($assigned_milestone->getName()) ?></a> - 
<?php if($assigned_milestone->isUpcoming()) { ?>
            <span><?php echo lang('days left', $assigned_milestone->getLeftInDays()) ?></span>
			<?php $htv_milestone_arr[$assigned_milestone->getId()]['status'] = 'upcoming' ?>
			<?php $htv_milestone_arr[$assigned_milestone->getId()]['days'] = $assigned_milestone->getLeftInDays() ?>
<?php } elseif($assigned_milestone->isLate()) { ?>
            <span class="error"><?php echo lang('days late', $assigned_milestone->getLateInDays()) ?></span>
			<?php $htv_milestone_arr[$assigned_milestone->getId()]['status'] = 'late' ?>
			<?php $htv_milestone_arr[$assigned_milestone->getId()]['days'] = $assigned_milestone->getLateInDays() ?>
<?php } elseif($assigned_milestone->isToday()) { ?>
            <span><?php echo lang('today') ?></span>
			<?php $htv_milestone_arr[$assigned_milestone->getId()]['status'] = 'today' ?>
			<?php $htv_milestone_arr[$assigned_milestone->getId()]['days'] = 0 ?>
<?php } // if ?><?php $htv_milestone_arr[$assigned_milestone->getId()]['url'] = $assigned_milestone->getViewUrl() ?>
          </td>
        </tr>
<?php } // foreach?>
      </table>
<?php } // if ?>

<?php if(is_array($assigned_tasks) && count($assigned_tasks)) { ?>
      <p><a href="<?php echo $active_project->getTasksUrl() ?>"><?php echo lang('tasks') ?></a>:</p>
      <table class="blank">
<?php foreach($assigned_tasks as $assigned_task) { ?>
        <tr>
          <td class="taskCheckbox"><?php echo checkbox_link($assigned_task->getCompleteUrl(), false, lang('mark task as completed')) ?></td>
          <td class="taskText">
<?php $assigned_to = $assigned_task->getAssignedTo() ?>
<?php if($assigned_to instanceof Company) { ?>
            <span class="assignedTo"><?php echo clean($assigned_to->getName()) ?>:</span>
<?php } elseif($assigned_to instanceof User) { ?>
            <span class="assignedTo"><?php echo clean($assigned_to->getDisplayName()) ?>:</span>
<?php } else { ?>
            <span class="assignedTo"><?php echo lang('anyone') ?>:</span>
<?php } // if ?>
            <?php echo clean($assigned_task->getText()) ?>
			<?php $htv_task_arr['taskid' . $assigned_task->getId()]['taskid'] = $assigned_task->getId() ?>
			<?php $htv_task_arr['taskid' . $assigned_task->getId()]['text'] = clean($assigned_task->getText()) ?>
			<?php $htv_task_arr['taskid' . $assigned_task->getId()]['taskurl'] = $assigned_task->getObjectUrl() ?>
<?php if($assigned_task->getTaskList() instanceof ProjectTaskList) { ?>
			<?php $htv_tasklist_arr[$assigned_task->getTaskList()->getId()]['id'] = $assigned_task->getTaskList()->getId() ?>
			<?php $htv_tasklist_arr[$assigned_task->getTaskList()->getId()]['name'] = clean($assigned_task->getTaskList()->getName()) ?>
			<?php $htv_tasklist_arr[$assigned_task->getTaskList()->getId()]['url'] = $assigned_task->getTaskList()->getViewUrl() ?>
			<?php
				if (isset($htv_tasklist_arr[$assigned_task->getTaskList()->getId()]['tasks']) == false) $htv_tasklist_arr[$assigned_task->getTaskList()->getId()]['tasks'] = '';
				$htv_tasklist_arr[$assigned_task->getTaskList()->getId()]['tasks'] .= ',' . $assigned_task->getId();
			?>
			<?php $htv_tasklist_arr[$assigned_task->getTaskList()->getId()]['milestoneid'] = $assigned_task->getTaskList()->getMilestoneId() ?>
			<?php $htv_task_arr['taskid' . $assigned_task->getId()]['tasklistid'] = $assigned_task->getTaskList()->getId() ?>
            (<?php echo lang('in') ?> <a href="<?php echo $assigned_task->getTaskList()->getViewUrl() ?>"><?php echo clean($assigned_task->getTaskList()->getName()) ?></a>)
<?php } // if ?>
          </td>
        </tr>
		<?php $htv_task_arr['taskid' . $assigned_task->getId()]['order'] = $assigned_task->getOrder() ?>
		<?php $htv_task_arr['taskid' . $assigned_task->getId()]['projectid'] = $active_project->getId() ?>
<?php } // foreach ?>
      </table>
<?php } // if ?>
    </div>
  </div>
<?php } // if ?>

<?php } // foreach ?>

<?php // sort the new array

   $sort_arr = array();
   foreach($htv_task_arr AS $uniqid => $row){
       foreach($row AS $key=>$value){
           $sort_arr[$key][$uniqid] = $value;
       }
   }

	array_multisort($sort_arr['order'], SORT_ASC, SORT_NUMERIC, $htv_task_arr);

?>

<?php

$listArray = array();

foreach($htv_task_arr as $htv_task) {
	$htv_milestone_highlight = '';
	//if ($htv_tasklist_arr[$htv_task['tasklistid']]['milestoneid'] > 0) {
	if (isset($htv_milestone_arr[$htv_tasklist_arr[$htv_task['tasklistid']]['milestoneid']])) {
		if ($htv_milestone_arr[$htv_tasklist_arr[$htv_task['tasklistid']]['milestoneid']]['status'] <> 'upcoming') $htv_milestone_highlight = ' style="background-color:#FFBFBF;"';
		$htv_milestone_output = '<a href="' . $htv_milestone_arr[$htv_tasklist_arr[$htv_task['tasklistid']]['milestoneid']]['url'] . '">' . $htv_milestone_arr[$htv_tasklist_arr[$htv_task['tasklistid']]['milestoneid']]['days'] . ' dys' . '</a>';
	}
	else $htv_milestone_output = 'N/A';
	$listArray[] = sprintf($listItemFormat,$htv_task['taskid'],$htv_task['tasklistid'],$htv_milestone_highlight,'<table border="0" cellspacing="0" cellpadding="0" width="100%"><tr><td style="width:45%;">' . '<a href="' . $htv_task['taskurl'] . '">' . htv_shorten($htv_task['text'], 42) . '</a>' . '</td><td style="width:27%;">' . '<a href="' . $htv_tasklist_arr[$htv_task['tasklistid']]['url'] . '">' . htv_shorten($htv_tasklist_arr[$htv_task['tasklistid']]['name'], 24) . '</a>' . '</td><td style="width:10%; text-align:center;">' . $htv_milestone_output .   '</td><td style="width:18%;">' . '<a href="' . $htv_project_arr[$htv_task['projectid']]['url'] . '">' . htv_shorten($htv_project_arr[$htv_task['projectid']]['name'],16) . '</a>' . '</td></tr></table>');
}

$listHTML = implode("\n",$listArray);
?>

	<?php
	$sortableLists->printTopJS();
	?>
<style>
ul#sortableList, ul#sortableHeading {
	list-style-type: none;
	padding: 0 0 0 0;
	margin: 0px;
	width: 528px;
	border: 1px solid #CCCCCC;
}
ul#sortableList li {
	cursor: row-resize;
	padding: 0px 0px;
	margin: 0px 0px;
	background-color: #F8F8F8;
	font-family: Arial, Helvetica, sans-serif;
	font-size: 11px;
}
ul#sortableList table, ul#sortableHeading table {
<?php if(strstr($_SERVER['HTTP_USER_AGENT'], "MSIE")) echo 'margin-bottom:-4px;' ; // tmp IE fix ?>
}
ul#sortableList table tr td, ul#sortableHeading table, tr, td {
	text-align:left;
	padding-left:5px;
	padding-right:5px;
}
ul#sortableHeading li {
	padding: 0px 0px;
	margin: 0px 0px;
	background-color: #E8E8E8;
	font-family: Arial, Helvetica, sans-serif;
	font-size: 11px;
	font-weight: bold;
	color: #003562;
}
ul#sortableHeading {
	border-bottom: 0px;
}
</style>
<hr />
<a name="prioritask"></a>
<h2>Prioritask</h2>
<ul id="sortableHeading"><li><table border="0" cellspacing="0" cellpadding="0" width="100%"><tr><td style="width:45%;">Task</td><td style="width:27%;">Tasklist</td><td style="width:10%; text-align:center;">M/stone</td><td style="width:18%;">Project</td></tr></table></li></ul>
<?php
printf($listFormat, $listHTML);
$sortableLists->printForm(ROOT_URL . '/index.php?c=dashboard&a=my_tasks', 'POST', 'Save Order', 'button');
$sortableLists->printBottomJS();
?>
<script language="JavaScript" type="text/javascript">

// colours to be used by Effect.Highlight
var hlColour = '#ffff99'; // light yellow
var origColour = '#F8F8F8'; // light gray
var overdueColour = '#FFBFBF'; // light red
var useColour;
var strtColour;
var endColour;

function TLMemberHL(taskList, part) {
	switch(taskList) {
		<?php
		foreach ($htv_tasklist_arr as $TLMemberList) {
			echo 'case ' . $TLMemberList['id'] . ':' . "\n";
			//if ($TLMemberList['milestoneid'] > 0 && $htv_milestone_arr[$TLMemberList['milestoneid']]['status'] <> 'upcoming') echo 'useColour = overdueColour;' . "\n";
			if (isset($htv_milestone_arr[$TLMemberList['milestoneid']]) && $htv_milestone_arr[$TLMemberList['milestoneid']]['status'] <> 'upcoming') echo 'useColour = overdueColour;' . "\n";
			else echo 'useColour = origColour;' . "\n";
			echo 'if(part == 1) {strtColour = useColour; endColour = hlColour;}';
			echo 'else {strtColour = hlColour; endColour = useColour;}';
			$explode_arr = explode(',', substr($TLMemberList['tasks'], 1)); // explode after removing first comma ','
			foreach ($explode_arr as $TLMember) {
				echo "new Effect.Highlight('item_" . $TLMember . "', {startcolor: strtColour, endcolor: endColour, restorecolor: endColour});\n";
			}
			echo 'break;';
			echo "\n\n";
		}
		?>
	}
}

function in_array(needle, haystack) {
    for (var i = 0; i < haystack.length; i++) {
        if (haystack[i] == needle) {
            return true;
        }
    }
    return false;
}

function makeTasklistOrder() {
	var taskArr = Sortable.serialize('sortableList').substring(15).split('&sortableList[]=');
	var taskListArr = new Array(<?php echo count($htv_tasklist_arr) ?>);
	var i = <?php echo count($htv_tasklist_arr) -1 ?>;
	taskArr.reverse();
	for (task in taskArr) {
    	if (task != "flatten") {
			taskListId = document.getElementById('item_' + taskArr[task]).getAttribute('tasklist');
			if (in_array(taskListId,taskListArr) == false) {
				// alert(taskListId + ' not found, will be added');
				taskListArr[i] = taskListId;
				i--;
			}
			// else alert(taskListId + ' found');			
		}
	}
	// add the tasklist order to a hidden input, using prototype's Insertion
	new Insertion.Bottom('sortableListForm', '<input type="hidden" name="taskListOrder" id="taskListOrder" value="' + taskListArr.join() + '" >');
	// alert(document.sortableListForm.taskListOrder.value);
}

Draggables.addObserver({
   onStart: function(event) {
	  TLMemberHL(parseInt($(event.element).getAttribute('tasklist')), 1);
   },
   onEnd: function(event) {
	  TLMemberHL(parseInt($(event.element).getAttribute('tasklist')), 2);
   }
});

// check if order has changed on exit and if so warn of losing changes
var doChangeCheck = true;
var originalOrder;

// code to stop the alert coming up if the form is submitted by disabling the Change Check
Event.observe(window, 'load', function() {
  Event.observe('sortableListForm', 'submit', function() { doChangeCheck = false; makeTasklistOrder(); });
  originalOrder = Sortable.serialize('sortableList');
});

window.onbeforeunload = function() {
	if (originalOrder != Sortable.serialize('sortableList') && doChangeCheck) return 'Any order changes will be lost!';
}

</script>

</div>
<?php } else { ?>
<p><?php echo lang('no active projects in db') ?></p>
<?php } // if  ?>

<?php if(!$has_assigned_tasks) { ?>
<p><?php echo lang('no my tasks') ?></p>
<?php } // if ?>